Subject: Re: BUG: commit-graph.c:1068 when doing `git pull`

From: Taylor Blau <[email-masked]>
Date: Thu, 12 Nov 2020 09:42:53 -0500

Hi Caspar,

On Mon, Nov 02, 2020 at 08:12:07PM +0100, herr.kaste wrote:
> A
>
>     $ git commit-graph write
>
> did the trick.
>
> Let me know if you think there could be something useful to reproduce,
> somewhere.

I think this is worth trying to reproduce. The first message you're
seeing about the commit-graph-chain.lock already existing is a
red-herring: it's likely that the last time you tried to generate a
commit-graph, that it hit that same BUG() and left the stale lock laying
around. (I can't remember off the top of my head whether we still run
the atexit handlers upon a BUG(), but even still, I could believe that
some other stray process left it laying around, too).

So, what's interesting is why your commit graph ended up in a state that
it got some commit without all of its parents. If you could reproduce
that state, that would be interesting.

Are you using shallow or partial clones?

> Regards
> Caspar Duregger
>
> Am Mo., 2. Nov. 2020 um 19:30 Uhr schrieb herr.kaste <[email-masked]>:
> >
> > Hi all!
> >
> > I'm stuck with this error message
> >
> >     $ git pull
> >     BUG: commit-graph.c:1068: missing parent
> > 104f5eb377763b2ed9663e8949aed265b69f000f for commit
> > c59ed9b7b6d4268ae6cb1069a9b51e02ad9aa1d8
> >
> > This happens since the last `fetch --prune origin`.
> >
> > If I do it again, I get
> >
> >     $ git pull
> >     fatal: Unable to create 'C:/Users/c-flo/AppData/Roaming/Sublime
> > Text 3/Packages/GitSavvy/.git/objects/info/commit-graphs/commit-graph-chain.lock':
> > File exists.
> >     ...
> >
> > And upon removing that file, I get the first error message again.
> >
> > I actually don't know yet how to move on from here.  I'm stuck, so I
> > appreciate any help.
> >
> >     $ git --version
> >     git version 2.29.2.windows.1
> >
> >
> > Regards
> > Caspar Duregger

Thanks,
Taylor